package org.artifactory.metrics.framework;

import com.jfrog.sysconf.SysConfig;
import org.artifactory.common.home.ArtifactoryHome;
import org.artifactory.security.access.AccessService;
import org.artifactory.storage.binstore.service.GarbageCollectionDatastoreService;
import org.artifactory.test.ArtifactoryHomeBoundTest;
import org.artifactory.test.TestUtils;
import org.junit.Before;
import org.testng.annotations.Test;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;
import static org.testng.Assert.assertFalse;
import static org.testng.Assert.assertTrue;

public class MetricsServiceImplTest extends ArtifactoryHomeBoundTest {

    private SysConfig sysConfig;
    private AccessService accessService;
    private GarbageCollectionDatastoreService garbageCollectionDatastoreService;

    @Before
    public void setUp() {
        garbageCollectionDatastoreService = mock(GarbageCollectionDatastoreService.class);
        accessService = mock(AccessService.class);
        sysConfig = mock(SysConfig.class);
        TestUtils.setField(ArtifactoryHome.get(), "sysConfig", sysConfig);
    }

    @Test
    public void testMetricsService() {
        MetricsServiceImpl metricsService = new MetricsServiceImpl(accessService, garbageCollectionDatastoreService);
        SysConfig sysConfig = mock(SysConfig.class);
        TestUtils.setField(ArtifactoryHome.get(), "sysConfig", sysConfig);

        when(sysConfig.getBoolean("artifactory.metrics.enabled", false)).thenReturn(false);
        metricsService.onContextCreated();
        assertFalse(metricsService.isMetricServiceRunning());

        when(sysConfig.getBoolean("artifactory.metrics.enabled", false)).thenReturn(true);
        when(sysConfig.get("artifactory.metrics.exclude", "")).thenReturn("");
        metricsService.onContextCreated();
        assertTrue(metricsService.isMetricServiceRunning());
    }

}