package org.artifactory.projects;

import org.testng.Assert;
import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

/**
 * @author BarakH
 */
public class ProjectsUtilsTest {

    @Test(dataProvider = "provideProjectNames")
    public void testIsDefaultProject(String project, boolean isDefault) {
        boolean result = ProjectsUtils.isDefaultProject(project);
        Assert.assertEquals(result, isDefault);
    }

    @DataProvider
    public static Object[][] provideProjectNames() {
        return new Object[][] {
                {null, true},
                {"", true},
                {ProjectsService.DEFAULT_PROJECT, true},
                {"DEFAULT", true},
                {"project", false},
                {"default-project", false},
        };
    }
}
