Name:           jfrog-artifactory-oss
Provides:       artifactory = %{artifactory_version}
Obsoletes:      artifactory >= 3.6.0
Conflicts:      jfrog-artifactory-pro jfrog-artifactory-vrcs jfrog-artifactory-cpp-ce jfrog-artifactory-jcr artifactory < 3.6.0
Version:        %{artifactory_version}
Release:        %{artifactory_release}
Summary:        Binary Repository Manager
Vendor:         JFrog Ltd.
Group:          Development/Tools
License:        AGPL-V3
URL:            http://www.jfrog.org
Source0:        standalone.tar.gz
BuildRoot:      %{_tmppath}/build-%{name}-%{version}
BuildArch:      x86_64
Requires:       %{_sbindir}/useradd, %{_sbindir}/groupadd, tar, %{_bindir}/pkill, %{_bindir}/rsync net-tools

%define username artifactory
%define group_name artifactory
%define extracted_standalone %{_sourcedir}/*artifactory*/app
%define extracted_tomcat %{extracted_standalone}/artifactory/tomcat
%define compressed_third_party %{extracted_standalone}/third-party.tar.gz
%define _rpmfilename %{filename_prefix}-%{full_version}.rpm

# Added to ignore debug logs
# %define _unpackaged_files_terminate_build 0

# Turn off binary stripping to avoid corruption of frontend binary - http://livecipher.blogspot.com/2012/06/disable-binary-stripping-in-rpmbuild.html
%global __os_install_post %{nil}

# Do not extract debug info from frontend binary - causing it to not work on target machine
%define  debug_package %{nil}

%define _binaries_in_noarch_packages_terminate_build 0

# Exclude automatic dependency find on new relic directory - this functionality in frontend is exposed only on SAAS deployment
%global __requires_exclude_from newrelic/.*$

%define target_jfrog_home /opt/jfrog
%define target_product_home %{target_jfrog_home}/artifactory
%define old_tomcat_home %{target_product_home}/tomcat
%define target_artifactory_install %{target_product_home}/app

# non-service home root directories
%define target_jfrog_doc %{target_artifactory_install}/doc
%define target_jfrog_bin %{target_artifactory_install}/bin
%define target_jfrog_misc %{target_artifactory_install}/misc
%define third_party_name third-party
%define target_jfrog_third_party %{target_artifactory_install}/%{third_party_name}
%define target_jfrog_third_party_tar %{target_artifactory_install}/%{third_party_name}.tar.gz

# Files used in the script
%define target_jfrog_default_env %{target_artifactory_install}/bin/artifactory.default
%define target_migrate_script %{target_artifactory_install}/bin/migrate.sh
%define target_jfrog_yaml_helper %{target_artifactory_install}/bin/systemYamlHelper.sh
%define target_jfrog_installer_common %{target_artifactory_install}/bin/installerCommon.sh
%define target_jfrog_artifactory_common %{target_artifactory_install}/bin/artifactoryCommon.sh

# service names
%define artifactory_name artifactory
%define router_name router
%define frontend_name frontend
%define metadata_name metadata

# microservice directories
%define target_art_service_dir %{target_artifactory_install}/%{artifactory_name}
%define target_router_dir %{target_artifactory_install}/%{router_name}
%define target_frontend_dir %{target_artifactory_install}/%{frontend_name}
%define target_metadata_dir %{target_artifactory_install}/%{metadata_name}

%define	target_tomcat_home %{target_art_service_dir}/tomcat
%define target_etc_dir_old /etc%{target_artifactory_install}
%define target_var_dir /var%{target_jfrog_home}
%define target_artifactory_home %{target_var_dir}/artifactory
%define lib_folder /usr/lib

%description
The best binary repository manager around.

%prep
%setup -q -T -c
%{__tar} -xzf "%{SOURCE0}" -C "%{_sourcedir}"
%{__tar} -czf %{_sourcedir}/%{third_party_name}.tar.gz -C %{extracted_standalone} %{third_party_name}

# Remove migration yaml related to other distributions
%__rm -f %{extracted_standalone}/bin/migrationCompose*.yaml %{extracted_standalone}/bin/migrationDocker*.yaml %{extracted_standalone}/bin/migrationZip*.yaml

%build

%install
%__rm -rf %{buildroot}

# Install and copy the files in the install dir (opt) directories
%__install -d "%{buildroot}%{target_artifactory_install}"
%__install -d "%{buildroot}%{target_jfrog_doc}"
%__install -d "%{buildroot}%{target_jfrog_bin}"
%__install -d "%{buildroot}%{target_jfrog_misc}"

%__cp -r %{extracted_standalone}/bin/* "%{buildroot}%{target_jfrog_bin}/"
%__cp -r %{extracted_standalone}/misc/* "%{buildroot}%{target_jfrog_misc}/"
%__cp -r %{extracted_standalone}/doc/* "%{buildroot}%{target_jfrog_doc}/"
%__cp %{_sourcedir}/%{third_party_name}.tar.gz "%{buildroot}%{target_jfrog_third_party_tar}"

# Install and copy the extra services
%__install -d "%{buildroot}%{target_art_service_dir}"
%__install -d "%{buildroot}%{target_router_dir}"
%__install -d "%{buildroot}%{target_frontend_dir}"
%__install -d "%{buildroot}%{target_metadata_dir}"

%__cp -r %{extracted_standalone}/%{artifactory_name}/* "%{buildroot}%{target_art_service_dir}/"
%__cp -r %{extracted_standalone}/%{router_name}/* "%{buildroot}%{target_router_dir}/"
%__cp -r %{extracted_standalone}/%{frontend_name}/* "%{buildroot}%{target_frontend_dir}/"
%__cp -r %{extracted_standalone}/%{metadata_name}/* "%{buildroot}%{target_metadata_dir}/"

rsync -r --exclude 'work' --exclude 'temp'  %{extracted_tomcat}/* "%{buildroot}%{target_tomcat_home}/"
%__cp %{extracted_standalone}/misc/service/setenv.sh "%{buildroot}%{target_tomcat_home}/bin/"

# Copy the contents of the standalone etc to the artifactory etc dir
%__install -D %{extracted_standalone}/misc/service/artifactory "%{buildroot}%{_sysconfdir}/init.d/artifactory"
%__install -D %{extracted_standalone}/misc/service/artifactory.service "%{buildroot}%{lib_folder}/systemd/system/artifactory.service"

# Replace the vars in the init and default scripts
%__sed -r --in-place "s%.*export JF_PRODUCT_HOME=.*%export JF_PRODUCT_HOME=%{target_product_home}%g;" "%{buildroot}%{target_jfrog_default_env}"
%__sed -r --in-place "s%.*export TOMCAT_HOME=.*%export TOMCAT_HOME=%{target_tomcat_home}%g;" "%{buildroot}%{target_jfrog_default_env}"
%__sed -r --in-place "s%Dartdist=zip%Dartdist=rpm%g;" "%{buildroot}%{target_jfrog_default_env}"

# Replace the vars in the init and default scripts
%__sed -r --in-place "s|__ARTIFACTORY_ENV_FILE__|%{target_jfrog_default_env}|g;" "%{buildroot}%{_sysconfdir}/init.d/artifactory"

%clean
%__rm -rf %{_builddir}/artifactory-%{version}

%pre

CURRENT_USER=$(id -nu)
if [ "$CURRENT_USER" != "root" ]; then
    echo
    echo "ERROR: Please install Artifactory using root."
    echo
    exit 1
fi

# Pack name of this product
PACK_NAME=jfrog-artifactory-oss
# minimum version from which upgrade is supported
MIN_VERSION=6.0.0

# Reference https://stackoverflow.com/questions/4023830/how-to-compare-two-strings-in-dot-separated-version-format-in-bash/4025065#4025065
is_number() {
    case "$BASH_VERSION" in
        3.1.*)
            PATTERN='\^\[0-9\]+\$'
            ;;
        *)
            PATTERN='^[0-9]+$'
            ;;
    esac

    if [[ "$1" =~ $PATTERN ]]; then
        return 0
    else 
        return 1
    fi
}

io_compareVersions() {
    if [[ $# != 2 ]]
    then
        echo "Usage: min_version current minimum"
        return
    fi

    A=$(echo "$1" | awk -F"." '{print $1}')
    B=$(echo "$2" | awk -F"." '{print $1}')

    if [[ "$A" != "$1" && "$B" != "$2" && "$A" == "$B" ]]
    then
        io_compareVersions "${1#*.}" "${2#*.}"
    else
        if is_number "$A" && is_number "$B"
        then
            if [[ "$A" -eq "$B" ]]; then
                echo "0"
            elif [[ "$A" -gt "$B" ]]; then
	            echo "1"
	        elif [[ "$A" -lt "$B" ]]; then
	            echo "-1"
            fi
        fi
    fi
}

isUpgradeAllowed(){
    local packName=$1
    local minVersion=$2
    local name=
    local version=
    local type=

    if [ -z "${packName}" ] || [ -z "${minVersion}" ]; then
        return 0
    fi

    arrIN=(${packName//=/ })
    packName=${arrIN[0]}

    if dpkg-query --version >/dev/null 2>&1 ; then
        type="deb"
    elif rpm --version >/dev/null 2>&1; then
        type="rpm"
    else
        echo "Could not find rpm or dpkg-query to get previous version information, skipping version check"
        return 0
    fi

    case $type in
        rpm)
            name="$(rpm -qa --nosignature --queryformat '%{NAME}\n' ${packName} 2>/dev/null)"
            version="$(rpm -qa --nosignature --queryformat '%{VERSION}\n' ${packName} 2>/dev/null)"
        ;;
        deb)
            name=$(dpkg-query -W -f='${binary:Package}' ${packName} 2>/dev/null)
            version=$(dpkg-query -W -f='${Version}' ${packName} 2>/dev/null)
        ;;
    esac

    # if name and version is not available consider it as not installed and return 1
    # let the caller decide what to do based on this response
    if [ -z "${name}" ] || [ -z "${version}" ]; then
        return 0
    fi

    version=${version//-/.}
    minVersion=${minVersion//-/.}

    if [ "$(io_compareVersions "${version}" "${minVersion}")" == "0" ] || [ "$(io_compareVersions "${version}" "${minVersion}")" == "1" ]; then
        return 0
    else
        echo
        echo "To upgrade from version ${version} and below, you first need to upgrade to Artifactory version 6.x as described in the Upgrading Artifactory documentation (https://service.jfrog.org/installer/Upgrading+Artifactory), and then continue to upgrading from version 6.x to 7.x"
        echo
        exit 1
    fi
}

isUpgradeAllowed "${PACK_NAME}" "${MIN_VERSION}"

SERVICE_FILE="%{_sysconfdir}/init.d/artifactory"
SERVICE_SYSTEMD_FILE="%{lib_folder}/systemd/system/artifactory.service"

if [ -e "$SERVICE_FILE" ]; then
    # Shutting down the artifactory service if running
    SERVICE_STATUS="$(${SERVICE_FILE} status)"
    if [[ ! "$SERVICE_STATUS" =~ .*[sS]topped.* ]]; then
        echo "Stopping the artifactory service..."
        ${SERVICE_FILE} stop || exit $?
    fi
fi

if [ -e "$SERVICE_SYSTEMD_FILE" ]; then
    # Shutting down the artifactory service if running
    awk -F/ '$2 == "docker"' /proc/self/cgroup | read
    DOCKER_VERIFICATION=$?
    if [[ ${DOCKER_VERIFICATION} -eq 0 ]] ; then
        # Shutting down the artifactory service if running
        ARTIFACTORY_MANAGE_FILE=%{target_artifactory_install}/bin/artifactoryManage.sh
        SERVICE_STATUS="$($ARTIFACTORY_MANAGE_FILE status)"
        if [[ ! "$SERVICE_STATUS" =~ .*[sS]topped.* ]]; then
            echo "Stopping the artifactory service..."
            $ARTIFACTORY_MANAGE_FILE stop || exit $?
        fi
    else
        # Shutting down the artifactory service if running
        SERVICE_STATUS="$(systemctl status artifactory.service)"
        if [[ ! "$SERVICE_STATUS" =~ .*[sS]topped.* ]]; then
            echo "Stopping the artifactory service..."
            systemctl stop artifactory.service || exit $?
        fi
    fi
fi

[ -e /etc/opt/jfrog/artifactory ] && read uid gid <<<$(stat -c '%u %g' /etc/opt/jfrog/artifactory)

if [ "$1" = "1" ]; then
    # Initial installation
    echo "Checking if group %{group_name} exists..."
    getent group "%{group_name}" 2>&1 1>/dev/null
    if [ $? != 0  ]; then
      echo "Group %{group_name} doesn't exist. Creating ..."
      %{_sbindir}/groupadd -r %{group_name} ${gid:+-g} $gid|| exit $?
    else
      echo "Group %{group_name} exists."
    fi

    echo "Checking if user %{username} exists..."
    getent passwd "%{username}" 2>&1 1>/dev/null
    if [ $? != 0 ]; then
      echo "User %{username} doesn't exist. Creating ..."
      %{_sbindir}/useradd %{username} -g %{username} -M -s /usr/sbin/nologin ${uid:+-u} $uid || exit $?
    else
      echo "User %{username} exists."
    fi

elif [ "$1" = "2" ]; then
    # Upgrade
    if [ -f %{target_etc_dir_old}/default ]; then
        username=$(grep ARTIFACTORY_USER %{target_etc_dir_old}/default | awk '{print $2}' | awk -F '=' '{print $2}')
        group_name=$(grep ARTIFACTORY_USER %{target_etc_dir_old}/default | awk '{print $2}' | awk -F '=' '{print $2}')
    fi

    if [ -f "%{target_jfrog_default_env}" ]; then
      # Support getting user and group from system.yaml
      source %{target_jfrog_default_env}
      export YQ_PATH="${JF_PRODUCT_HOME}/app/third-party/yq"

      if [[ -f "%{target_jfrog_yaml_helper}" && -f "%{target_jfrog_installer_common}" && -f "%{target_jfrog_artifactory_common}" && -f "$YQ_PATH/yq" ]]; then
          export JF_SYSTEM_YAML="${JF_PRODUCT_HOME}/var/etc/system.yaml"
          source %{target_jfrog_yaml_helper}
          source %{target_jfrog_installer_common}
          source %{target_jfrog_artifactory_common}

          setUserGroup "${username}"

          username=$JF_ARTIFACTORY_USER
          group_name=$JF_ARTIFACTORY_GROUP
      fi
    fi
fi

# Cleaning the artifactory webapp and work folder

echo "Removing tomcat work directory"
if [ -d "%{target_tomcat_home}/work" ]; then
  %__rm -rf %{target_tomcat_home}/work || exit $?
fi

if [ -d "%{target_tomcat_home}/webapps/artifactory" ]; then
  echo "Removing Artifactory's exploded WAR directory"
  %__rm -rf %{target_tomcat_home}/webapps/artifactory || exit $?
fi

if [ -d "%{old_tomcat_home}/webapps/artifactory" ]; then
  echo "Removing Artifactory's exploded WAR directory from old location"
  %__rm -rf %{old_tomcat_home}/webapps/artifactory || exit $?
fi

if [ -d "%{old_tomcat_home}/webapps/access" ]; then
  echo "Removing access exploded WAR directory from old location"
  %__rm -rf %{old_tomcat_home}/webapps/access || exit $?
fi

exit 0

%post -p /bin/bash

SERVICE_INIT_FILE="%{_sysconfdir}/init.d/artifactory"
SERVICE_SYSTEMD_FILE="%{lib_folder}/systemd/system/artifactory.service"
SERVICE_TYPE=""

# Extract third party in the target machine to avoid installation of java depedencies
THIRD_PARTY_TAR="%{target_jfrog_third_party_tar}"
if [ -f "${THIRD_PARTY_TAR}" ]; then
  if [ -d "%{target_jfrog_third_party}" ]; then
    echo "Cleaning up %{target_jfrog_third_party} to extract ${THIRD_PARTY_TAR}"
    rm -fr "%{target_jfrog_third_party}"
  fi
  extractFailed=false
  tar -xf "${THIRD_PARTY_TAR}" -C %{target_artifactory_install} 2>/dev/null >/dev/null || echo "Failed to extract java and yq, please try this command manually after installaton : tar -xf ${THIRD_PARTY_TAR} -C %{target_artifactory_install}" || extractFailed=true
  [ -f "${THIRD_PARTY_TAR}" ] && [ "$extractFailed" == "false" ] && rm -f "${THIRD_PARTY_TAR}" || true
fi

# Support getting user and group from system.yaml
if [ -f "%{target_jfrog_default_env}" ]; then
  source %{target_jfrog_default_env}
  export YQ_PATH="${JF_PRODUCT_HOME}/app/third-party/yq"

  if [[ -f "%{target_jfrog_yaml_helper}" && -f "%{target_jfrog_installer_common}" && -f "%{target_jfrog_artifactory_common}" && -f "$YQ_PATH/yq" ]]; then
      export JF_SYSTEM_YAML="${JF_PRODUCT_HOME}/var/etc/system.yaml"
      source %{target_jfrog_yaml_helper}
      source %{target_jfrog_installer_common}
      source %{target_jfrog_artifactory_common}

      setUserGroup

      username=$JF_ARTIFACTORY_USER
      group_name=$JF_ARTIFACTORY_GROUP

      setVarLinkOwnership "${JF_ARTIFACTORY_USER}" "${JF_ARTIFACTORY_GROUP}" "%{target_product_home}/var" "%{target_artifactory_home}" >/dev/null
      createRecursiveDir "${JF_PRODUCT_HOME}/var/bootstrap" "artifactory tomcat lib" "${JF_ARTIFACTORY_USER}" "${JF_ARTIFACTORY_GROUP}" >/dev/null
  fi
fi

if [ "$1" = "1" ]; then
  # New install
  echo -n "Adding the artifactory service to auto-start..."
  awk -F/ '$2 == "docker"' /proc/self/cgroup | read
  DOCKER_VERIFICATION=$?
  systemctl -h > /dev/null 2>&1
  if [[ $? -eq 0 ]] && [[ ${DOCKER_VERIFICATION} -gt 0 ]] ; then
        #File SERVICE_INIT_FILE exists, removing
        if [ -e ${SERVICE_INIT_FILE} ]; then
            rm -f ${SERVICE_INIT_FILE}
        fi
        systemctl daemon-reload &>/dev/null
        systemctl enable artifactory.service &>/dev/null
        systemctl list-unit-files --type=service | grep artifactory.service &>/dev/null || errorArtHome "Could not install artifactory service"
        SERVICE_TYPE="systemd"
  else
        #File SERVICE_SYSTEMD_FILE exists, removing since no systemd supported
        if [ -e ${SERVICE_SYSTEMD_FILE} ]; then
            rm -f ${SERVICE_SYSTEMD_FILE}
        fi
        /sbin/chkconfig --list artifactory 2>&1 1>/dev/null || /sbin/chkconfig --add artifactory
        SERVICE_TYPE="init.d"
  fi
  echo -e " DONE"
  echo
  echo "NOTE: Updating the ownership of files and directories. This may take several minutes. Do not stop the installation/upgrade process."
  chown -R %{username}: %{target_tomcat_home}/webapps
  chown -R %{username}: %{target_product_home}/var/
  echo
  echo "The installation of Artifactory has completed successfully."
  echo
  echo "NOTE: It is highly recommended to use Artifactory with an external database (MySQL, Oracle, Microsoft SQL Server, PostgreSQL, MariaDB)."
  echo "      For details about how to configure the database, refer to https://service.jfrog.org/installer/Configuring+the+Database"
  echo
    if [ ${SERVICE_TYPE} == "init.d" ]; then
        echo "You can now check installation by running:"
        echo "> service artifactory check (or $SERVICE_INIT_FILE check)"
        echo
        echo "Then activate artifactory with:"
        echo "> service artifactory start (or $SERVICE_INIT_FILE start)"
    fi
    if [ ${SERVICE_TYPE} == "systemd" ]; then
        echo "Start Artifactory with:"
        echo "> systemctl start artifactory.service"
        echo
        echo "Check Artifactory status with:"
        echo "> systemctl status artifactory.service"
    fi
    echo
    echo "Installation directory was set to ${JF_PRODUCT_HOME}"
    echo "You can find more information in the log directory ${JF_PRODUCT_HOME}/var/log"
    echo "System configuration templates can be found under ${JF_PRODUCT_HOME}/var/etc"
    echo "Copy any configuration you want to modify from the template to ${JF_PRODUCT_HOME}/var/etc/system.yaml"
    echo
elif [ $1 -gt 1 ]; then
    # Upgrade
    awk -F/ '$2 == "docker"' /proc/self/cgroup | read
    DOCKER_VERIFICATION=$?
    systemctl -h > /dev/null 2>&1
    if [[ $? -eq 0 ]] && [[ ${DOCKER_VERIFICATION} -gt 0 ]] ; then
        if [ -e ${SERVICE_INIT_FILE} ]; then
            mv ${SERVICE_INIT_FILE} ${SERVICE_INIT_FILE}.disabled
        fi
        echo "Initializing artifactory service with systemctl..."
        systemctl daemon-reload &>/dev/null
        systemctl enable artifactory.service &>/dev/null
        systemctl list-unit-files --type=service | grep artifactory.service &>/dev/null || errorArtHome "Could not install artifactory service"
        SERVICE_TYPE="systemd"
    else
        if [ -e ${SERVICE_SYSTEMD_FILE} ]; then
            rm -f ${SERVICE_SYSTEMD_FILE}
        fi
        /sbin/chkconfig --list artifactory 2>&1 1>/dev/null || /sbin/chkconfig --add artifactory
        SERVICE_TYPE="init.d"
    fi
  echo
  echo -e "\033[33m************ SUCCESS ****************\033[0m"
  echo -e "\033[33mThe upgrade of Artifactory has completed successfully.\033[0m"
  echo

    if [[ -f "%{target_migrate_script}" ]]; then
        echo "Triggering migration script, this will migrate if needed"
        migrationLog=%{target_product_home}/var/log/migration.log
        %{target_migrate_script}  1>/dev/null 2>&1 ||  \
        ( echo "######################################################################################################" ; \
          echo "WARNING: Migration failed. Check %{target_product_home}/var/log/migration.log for details" ; \
          echo "######################################################################################################" )
        [ -f "${migrationLog}" ] && chown ${JF_ARTIFACTORY_USER}:${JF_ARTIFACTORY_GROUP} "${migrationLog}" 1>/dev/null 2>&1 || true
    fi

    if [ ${SERVICE_TYPE} == "init.d" ]; then
        echo "You can now check installation by running:"
        echo "> service artifactory check (or $SERVICE_INIT_FILE check)"
        echo
        echo "Then activate artifactory with:"
        echo "> service artifactory start (or $SERVICE_INIT_FILE start)"
    fi
    if [ ${SERVICE_TYPE} == "systemd" ]; then
        echo "Start Artifactory with:"
        echo "> systemctl start artifactory.service"
        echo
        echo "Check Artifactory status with:"
        echo "> systemctl status artifactory.service"
    fi
  if [ -f "%{target_etc_dir_old}/default" ]; then
    username=$(grep ARTIFACTORY_USER %{target_etc_dir_old}/default | awk '{print $2}' | awk -F '=' '{print $2}')
  else
    username=${JF_ARTIFACTORY_USER:-artifactory}
  fi
  echo
  echo "Installation directory was set to ${JF_PRODUCT_HOME}"
  echo "You can find more information in the log directory ${JF_PRODUCT_HOME}/var/log"
  echo "System configuration templates can be found under ${JF_PRODUCT_HOME}/var/etc"
  echo "Copy any configuration you want to modify from the template to ${JF_PRODUCT_HOME}/var/etc/system.yaml"
  echo
  echo
  echo "NOTE: Updating the ownership of files and directories. This may take several minutes. Do not stop the installation/upgrade process."
  chown ${username}: %{target_tomcat_home}
  chown -R ${username}: %{target_tomcat_home}/webapps
  echo
fi

# Fix existing install with INST-767 issue
if [ -d "%{target_product_home}"/var/etc/artifactory/logrotate ]; then
    mv "%{target_product_home}"/var/etc/artifactory/logrotate "%{target_product_home}"/var/etc/logrotate 1>/dev/null 2>&1 ;
fi

# Configure log rotation - this should run after migration script (fix for INST-767)
configureLogRotation "artifactory" "${JF_PRODUCT_HOME}" "${username}" "${group_name}" >/dev/null || true

syncEtc

exit 0

%preun
if [ "$1" = "0" ]; then
  # It's an un-installation

  CURRENT_USER=$(id -nu)
  if [ "$CURRENT_USER" != "root" ]; then
    echo
    echo "ERROR: Please un-install Artifactory using root."
    echo
    exit 1
  fi

  SERVICE_FILE=%{_sysconfdir}/init.d/artifactory
  SERVICE_SYSTEMD_FILE=/etc/systemd/system/artifactory.service
  SERVICE_SYSTEMD_LIB_FILE=/usr/lib/systemd/system/artifactory.service

  if [ -f $SERVICE_FILE ]; then
    SERVICE_STATUS="$(${SERVICE_FILE} status)"
    if [[ ! "$SERVICE_STATUS" =~ .*[sS]topped.* ]]; then
      echo "Stopping the artifactory service..."
      $SERVICE_FILE stop || exit $?
    fi
    echo -n "Removing the artifactory service from auto-start..."
    /sbin/chkconfig --del artifactory 2>/dev/null
    if [ -f ${SERVICE_FILE} ]; then
        rm -f ${SERVICE_FILE} || exit "Could not delete $SERVICE_FILE"
    fi
    if [ -f ${SERVICE_FILE}.disabled ]; then
        rm -f ${SERVICE_FILE}.disabled || exit "Could not delete ${SERVICE_FILE}.disabled"
    fi
    echo -e " DONE"
  fi

  if [ -f ${SERVICE_SYSTEMD_FILE} ]; then
    SERVICE_STATUS="$(systemctl status artifactory.service)"
    if [[ ! "$SERVICE_STATUS" =~ .*[sS]topped.* ]]; then
      echo "Stopping the artifactory service..."
      systemctl stop artifactory.service || exit $?
    fi
    echo -n "Removing the artifactory service from auto-start..."
    systemctl disable artifactory.service &>/dev/null
    if [ -f ${SERVICE_SYSTEMD_FILE} ]; then
        rm -f ${SERVICE_SYSTEMD_FILE} || exit "Could not delete $SERVICE_SYSTEMD_FILE"
    fi
    if [ -f ${SERVICE_SYSTEMD_FILE}.disabled ]; then
        rm -f ${SERVICE_SYSTEMD_FILE}.disabled || exit "Could not delete ${SERVICE_SYSTEMD_FILE}.disabled"
    fi
    if [ -f ${SERVICE_SYSTEMD_LIB_FILE} ]; then
        rm -f ${SERVICE_SYSTEMD_LIB_FILE} || error "Could not delete $SERVICE_SYSTEMD_LIB_FILE"
    fi
    echo -e " DONE"
  fi

  # Create backups
  TIMESTAMP=$(echo "$(date '+%T')" | tr -d ":")
  CURRENT_TIME="$(date '+%Y%m%d').$TIMESTAMP"
  BACKUP_DIR="%{target_var_dir}/artifactory.backup.${CURRENT_TIME}"
  echo "Creating a backup of the artifactory home folder in ${BACKUP_DIR}"

  # ignore any failures or the package will be left in an inconsistent state
  %__mkdir_p "${BACKUP_DIR}" && \
  %__cp -a %{target_product_home}/var/etc "${BACKUP_DIR}/etc" && \
  %__cp -a %{target_product_home}/var/data "${BACKUP_DIR}/data" && \
  %__mv %{target_product_home}/var/log "${BACKUP_DIR}/log" 2>&1 1>/dev/null

  %__rm -rf "%{target_product_home}/var/tmp" 2>&1 1>/dev/null
  %__rm -rf "%{target_product_home}/var/work" 2>&1 1>/dev/null

  if [ -e %{target_tomcat_home}/lib/mysql-connector-java*.jar ]; then
    echo "MySQL connector found"
    %__cp %{target_tomcat_home}/lib/mysql-connector-java* "${BACKUP_DIR}" 2>/dev/null
  fi
  if [ -e %{target_product_home}/var/backup ]; then
    %__mv %{target_product_home}/var/backup "${BACKUP_DIR}/backup" 2>/dev/null
  fi
fi

exit 0

%postun

if [ "$1" = "0" ]; then
  JF_ARTIFACTORY_USER=${JF_ARTIFACTORY_USER:-artifactory}
  # It's an un-installation
  username=$JF_ARTIFACTORY_USER
  echo "Logging off user ${username}"
  %{_bindir}/pkill -KILL -u ${username}

  %__rm -rf %{target_product_home}/var/{work,temp} 2>/dev/null

  # Ignoring user folders since the home dir is deleted already by the RPM spec
  echo "Removing local user ${username}"
  ( grep -q ${username} /etc/passwd &&
  %{_sbindir}/userdel ${username} 2>/dev/null) || echo $?

  if [ -f "%{target_etc_dir_old}/default" ]; then
    group_name=$(grep ARTIFACTORY_USER %{target_etc_dir_old}/default* | awk '{print $2}' | awk -F '=' '{print $2}')
  else
    group_name=${JF_ARTIFACTORY_GROUP:-artifactory}
  fi

  EXISTING_GROUP="$(grep ${group_name} /etc/group | awk -F ':' '{ print $1 }' 2>/dev/null)"
  if [ "$EXISTING_GROUP" == "${group_name}" ]; then
    echo "Removing group ${group_name}"
    %{_sbindir}/groupdel ${group_name}
  fi

  # check if artifactory user exists (in case another user was default)
  getent passwd %{username} > /dev/null 2&>1
  if [ $? -eq 0 ]; then
    echo "Removing local user %{username}"
    %{_sbindir}/userdel %{username} 2>/dev/null || echo $?
    %{_sbindir}/groupdel ${group_name} 2>/dev/null
  fi

    echo
    echo -e "\033[33mUninstallation of Artifactory completed\033[0m"
fi
exit 0

%posttrans

echo post transaction %{name} \$1 = $1 >>/tmp/rpminst

exit 0

%triggerpostun -- artifactory
echo trigger post uninstall %{name} \$1 = $1 >>/tmp/rpminst
exit 0

%triggerun -- artifactory
echo trigger uninstall %{name} \$1 = $1 >>/tmp/rpminst
exit 0

%files
%dir %{target_jfrog_doc}
%dir %{target_artifactory_install}
%attr(775,root,root) %config %{_sysconfdir}/init.d/artifactory
%attr(755,root,root) %config %{lib_folder}/systemd/system/artifactory.service
%attr(775,root,root) %config %{target_jfrog_bin}
%attr(775,root,root) %config %{target_jfrog_misc}
%attr(775,root,root) %config %{target_frontend_dir}
%attr(775,root,root) %config %{target_router_dir}
%attr(775,root,root) %config %{target_metadata_dir}
%attr(774,root,root) %{target_jfrog_doc}/Artifactory-About-Box.html
%attr(774,root,root) %{target_jfrog_doc}/Access-About-Box.html
%attr(774,root,root) %{target_jfrog_doc}/Frontend-About-Box.html
%attr(774,root,root) %{target_jfrog_doc}/Metadata-About-Box.html
%attr(774,root,root) %{target_jfrog_doc}/Router-About-Box.html
%attr(774,root,root) %{target_jfrog_doc}/COPYING.AFFERO
%attr(774,root,root) %{target_jfrog_doc}/README.txt
%attr(775,root,root) %config %{target_tomcat_home}/bin
%attr(775,root,root) %config %{target_tomcat_home}/conf
%attr(775,root,root) %{target_tomcat_home}/lib
%attr(775,root,root) %{target_jfrog_third_party_tar}
%attr(775,root,root) %{target_tomcat_home}/webapps
%attr(774,root,root) %{target_tomcat_home}/LICENSE
%attr(774,root,root) %{target_tomcat_home}/NOTICE
%attr(774,root,root) %{target_tomcat_home}/RELEASE-NOTES
%attr(774,root,root) %{target_tomcat_home}/RUNNING.txt

%doc

%changelog
* __CHANGE_LOG_TIME_STAMP__ JFrog <dev@jfrog.com> - %{full_version}
- Refer https://service.jfrog.org/installer/Artifactory+Release+Notes for changes on this release.